<?php
/* ---------------------------------------------------------------------
    index.php - MotionBrowser - User interface for the result of Motion
                application. Developed by Carlos Ladeira
                (caladeira@gmail.com)

    Creation:     2006-03-11  Carlos Ladeira
    Last Update:  $Id: index.php 29623 2012-01-22 18:56:44Z jed $

    For more details, please visit:
    http://www.lavrsen.dk/twiki/bin/view/Motion/WebHome

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
   --------------------------------------------------------------------
    This web page reads the mysql database filled by Motion and output
    events by day It creates small thumbnail were you can click to
    watch the avi file for the same event. You can also delete the events
    you select.
    It's a good interface in case you are running Motion on a computer
    without monitor/keyboad/mouse, only network!
    It is supposed to work with the following motion.conf optios set as
    shown (for better results):

    pre_capture 8                 (works for me with a framerate of 6)
    post_capture 8                (ie)
    output_all off
    output_normal best (or) first
    output_motion off
    text_event %Y%m%d%H%M%S
    ffmpeg_cap_new on
    ffmpeg_video_codec msmpeg4
    sql_log_image on
    sql_log_snapshot off
    sql_log_mpeg on
    sql_log_timelapse off
    sql_query INSERT ...          (I use the default)
    mysql_db motion               (my database name)
    mysql_host localhost
    mysql_user ...                (the user name i created in MySQL)
    mysql_password ...            (the password associated with user)
   -------------------------------------------------------------------- */

    include("config.inc");
    setlocale(LC_ALL, $locales);
    include("calendar.inc");
    include("lang_".$lang);

    // read file size from file
    function read_filesize($fname)
    {
        $fsize=filesize($fname);

        $majsize = mysql_query("update security set file_size='$fsize' where filename ='$fname';") or die($err_upd_size);

        //mysql_free_result($majsize);
        return $fsize;
    }

    // read jpeg details from mjpeg stream
    function getimagesize_from_stream($wurl, $wcam)
    {
        $jpg_boundary="\n--";
        $fr = @fopen($wurl,"r");
        if($fr) {
            // url is ok, read jpeg frame from stream
            $r='';
            while (substr_count($r,"Content-Length") != 2) $r .= @fread($fr,512);

            $jpg_start = strpos($r,'');
            $jpg_end   = strpos($r,$jpg_boundary,$jpg_start)-1;
            $jpg_frame = substr("$r",$jpg_start,$jpg_end - $jpg_start);

            // save frame to temporary file
            $jpg_tmp   = 'mb-tmp-' . $wcam . '.jpg';
            if (!$fw = fopen($jpg_tmp, "a")) {
                print "unable to open file $jpg_tmp for writing";
                exit;
            }
            if (!fwrite($fw, $jpg_frame)) {
                print "unable to open file $jpg_tmp for writing";
                exit;
            }
            fclose($fw);

            // get image size
            $jpg_size = getimagesize($jpg_tmp);

            // delete temporary file
            unlink($jpg_tmp);

            return $jpg_size;
        }
//      else {
//          print "unable to open stream $wurl";
//      }
    }

    function create_movie_thumb($src_file)
    {
        $ffmpeg_cmd = '/usr/bin/ffmpeg';

        $src_parts = pathinfo($src_file);
        $dest_file = $src_parts['dirname'] . '/' . $src_parts['filename'] . '-thumb.jpg';

        switch ($src_parts['extension']) {
            case 'avi':
                $ssval='00:00:05';
                break;
            case 'mpg':
                // choose round about 09:00h
                $ssval='00:22:30';
                break;
            default:
                // if other type, ignore and jump to next row
                $ssval='00:00:05';
        }

        if (!file_exists($dest_file)) {
            // thumbnail doesn't exist, go on...
            $output = array();

            // command to create video thumb
            // -i           - input file name
            // -an          - disable audio recording
            // -ss 00:00:05 - seek to given time position in seconds, "hh:mm:ss[.xxx]" syntax is also supported
            // -r 1         - set frame rate (Hz value, fraction or abbreviation), (default = 25)
            // -vframes 1   - set the number of video frames to record
            // -y           - overwrite output files
            $cmd = escapeshellcmd("$ffmpeg_cmd -i $src_file -an -ss $ssval -r 1 -vframes 1 -y $dest_file");
            exec ($cmd, $output, $retval);

            if ($retval) {
                $dest_file = getcwd() . '/error.jpg';
                print "error executing ffmpeg - return value: $retval\n";
            }
        }

        return $dest_file;
    }

    // connect to database
    $db = mysql_connect($sql_host, $sql_user, $sql_pass) or die($err_sel_data);
    mysql_select_db($sql_db) or die($err_sel_size);

    // restore file path
    if (!isset($data_dir)) {
        $query = "SELECT filename FROM security order by time_stamp desc limit 0,1";
        $result = mysql_query($query) or die ($err_req_quota);
        $mquota = mysql_fetch_row($result);

        // find file path
        $maxquot=strlen($mquota[0]);
        for ($mq=$maxquot ; $mq >=0 ; $mq--)

        if (substr($mquota[0],$mq,1) == '/') {
            $data_dir = substr($mquota[0], 0, $mq);
            $mq=0;
        }

        mysql_free_result($result);
    }

    //
    // check if the delete form has been submited
    //
    if (isset($_GET['what'])) {
        if ($_GET['what'] == "delete") {

            // get the list of filenames we are going to delete
            $query = "SELECT filename FROM security WHERE event_time_stamp IN (".$_GET['todelete'].")";
            $result = mysql_query($query) or die ($err_sel_file);

            // loop for each one
            for ($i = 0; $i < mysql_num_rows($result); $i++) {
                $row = mysql_fetch_array($result);
                $filename = $row['filename'];

                // delete the file first
                if (!unlink($filename)) {
                    die($err_del_file.$filename); 
                }

                // if no problem, delete the record from the database
                $query = "DELETE FROM security WHERE filename='".$filename."'";
                mysql_query($query) or die ($err_del_req);
            }

            mysql_free_result($result);
        }
    }
?>

<html>
<head>
<title><?php echo $config_title;?></title>
<link rel="stylesheet" href="motionbrowser.css" type="text/css" media="all">
<script language="JavaScript">
<!--
//
// Validate the delete form submit
//
function validateForm(frm)
{
    var event_count = frm.event_count.value;   // load number of events
    var todelete = '';                         // string with the events to delete

    // loop trough all checkbox and check if they are checked
    for (i=1; i<=event_count; i++) {
        // if they are checked, add the event to the list to be deleted
        if (eval("frm.img"+i+".checked") == true) {
            if (todelete) todelete +=',';
            todelete += eval("frm.img"+i+".value");
        }
    }

    // if there are one or more events to delete ...
    if (todelete) {
        if (confirm("<?echo html_entity_decode($java_confirm_delete);?>")) {
            frm.todelete.value = todelete;
            return true;
        } else
            return false;
    }
    else {
        alert("<?echo html_entity_decode($java_select_delete);?>");
        return false;
    }
}

function select_all()
{
    var event_count = document.iform.event_count.value; // load number of events
    
    // loop trough all checkbox and check them
    for (i=1; i<=event_count; i++) {
        // if they are checked, add the event to the list to be deleted
        eval("document.iform.img"+i+".checked = true;");
    }
}

function select_none()
{
    var event_count = document.iform.event_count.value; // load number of events
    
    // loop trough all checkbox and uncheck them
    for (i=1; i<=event_count; i++) {
        // if they are checked, add the event to the list to be deleted
        eval("document.iform.img"+i+".checked = false;");
    }
}

function openwindow(url, title, xx, yy, nbr)
{
    var wh = open(url, title, 'locationbar=no,menubar=no,personalbar=no,scrollbars=no,status=no,titlebar=no,toolbar=no,resizable=yes,toolbar=yes,target=cam-' + nbr + ',width=' + xx + ',height=' + yy);
    wh.location.href = url;
    if (wh.opener == null) wh.opener = self;
    wh.focus();
}

function ToggleRowVisibility(intRowIndex)
{
    /* Mozilla 1.8alpha; see bug 77019 and bug 242368; must be higher than 1.7.x
    Mozilla 1.8a2 supports accordingly dynamic collapsing of rows in both border-collapse models
    but not 1.7.x versions */
    if(navigator.product == "Gecko" && navigator.productSub && navigator.productSub > "20041010" && (navigator.userAgent.indexOf("rv:1.8") != -1 || navigator.userAgent.indexOf("rv:1.9") != -1)) {
        document.getElementById("idtable").rows[intRowIndex].style.visibility =
            (document.getElementById("idtable").rows[intRowIndex].style.visibility == "visible") ? "collapse" : "visible";
    }
    else {
        if(document.all && document.compatMode && document.compatMode == "CSS1Compat" && !window.opera) {
            document.getElementById("idtable").rows[intRowIndex].style.display =
                (document.getElementById("idtable").rows[intRowIndex].style.display == "block") ? "none" : "block";
        }
        // Mozilla prior to 1.8a2, Opera 7.x and MSIE 5+
        else if(document.getElementById && document.getElementById("idtable").rows) {
            document.getElementById("idtable").rows[intRowIndex].style.display =
                (document.getElementById("idtable").rows[intRowIndex].style.display == "") ? "none" : "";
        }
    }
}

function plusclick(image)
{
    if (image.src.indexOf('sign_plus.gif') != -1) {
        image.src   = "./sign_minus.gif";
        image.alt   = "<?echo $list_collapse;?>";
        image.title = "<?echo $list_collapse;?>";
    } else {
        image.src   = "./sign_plus.gif";
        image.alt   = "<?echo $list_expand;?>";
        image.title = "<?echo $list_expand;?>";
    }
}

//-->
</script>
</head>

<?php
    // if no day has been selected in the calendar, use current time
    if (isset($_GET['view_date'])) {
        $view_date = $_GET['view_date'];
    } else {
        $view_date = time();
    }

    // get all events for the selected day in a order that allow us to
    // show the result in a nice way!
    $date = date('Y-m-d', $view_date);
    $query = 
        'SELECT *, TIME(event_time_stamp) as timefield, HOUR(event_time_stamp) as hourfield, '.
        'event_time_stamp+0 as time_stamp, file_size '.
        'FROM security '.
        "WHERE event_time_stamp >= '".$date." 00:00:00' ".
        "AND event_time_stamp <= '".$date." 23:59:59' ".
        'ORDER BY hourfield, camera, timefield, file_type';
    $result = mysql_query($query) or die ($err_sel_que1.$query);
    $numofrows = mysql_num_rows($result);

    // get also a list of all cameras that has events for the selected day
    // fill the $camera_list with the result
    $query = 
        'SELECT distinct camera '.
        'FROM security '.
        "WHERE event_time_stamp >= '".$date." 00:00:00' ".
        "AND event_time_stamp <= '".$date." 23:59:59' ".
        'ORDER BY camera';
    $camera_list = mysql_query($query) or die ($err_sel_que2.$query);
    $cameras = array();
// hier wird festgelegt wie viele Kameras im Zeilenkopf angezeigt werden!! Anpassen!
    $num_cameras = 0;
    for (; $num_cameras < mysql_num_rows($camera_list); $num_cameras++) {
        $row = mysql_fetch_array($camera_list);
        $cameras[$num_cameras] = $row['camera'];
    }
    mysql_free_result($camera_list);
?> 

<body>

<?php
    // count the number of events (images) on screen
    $event_count = 0;
    $row_count = 2;

    // prepare the form that will allow us to delete events
    echo "<form name=iform action=".$_SERVER['PHP_SELF']." method=get onSubmit=\"javascript:return validateForm(this);\">";
    echo "<input type=hidden name=view_date value=".$view_date.">";
    echo "<input type=hidden name=what value=delete>\n";
    echo "<input type=hidden name=todelete value=>\n";
    echo '<table border=0><tr><td align=center valign=top>';
    echo "<span class=title><b>$config_title</b></class>\n";
    echo "<center><br><br>\n";

    // draw calendar
    echo calendar($view_date);

    echo "<br>\n";
    echo "$selection<br>";
    echo "<a href=\"javascript:select_all();\">".$all."</a>&nbsp;&nbsp;|&nbsp;&nbsp;<a href=\"javascript:select_none();\">".$nothing."</a><br>\n";
    echo "<input type=submit value=\"$erase_selection\">\n";

    echo "<br><br>\n";
    echo "<p><a href=\"http://$server_name:$setup_port\" target=_blank>".$config_motion."</a></p>\n";
    echo "<p>&nbsp;</p>\n";
    echo "<span class=credits>$config_credits<br>";
    echo "<a href=\"$config_mailto\">$config_mailname</a></class>\n";
    echo "<br><br><br>\n";

    echo '</td><td>&nbsp;&nbsp;</td><td valign=top>';

    // if there are any events on the present day
    if ($numofrows != 0) {
        echo "<table id=idtable border=1 cellspacing=0 cellpadding=4 class=timeline>\n";

        // show the column header only if they have any event
        echo '<TR class=timeline-header><th>&nbsp;<a href="surveillance.php?nbr_x='.$cam_windows_x.'&nbr_y='.$cam_windows_y.'" target="surv">&nbsp;&nbsp;<img src=icon_eye.gif border=0 alt="'.$see_surveillance.'" title="'.$see_surveillance.'"></a>&nbsp;</th>';

        foreach ($cameras as $cam) {
            $webcam = "http://$server_name:".$webcam_port[($cam-1)]."/";

            $wc_width  = $webcam_x;
            $wc_height = $webcam_y;

            // get original image size
            $img_size = getimagesize_from_stream($webcam, $cam);
            $img_width  = $img_size[0];
            $img_height = $img_size[1];

         // print "1-W:($webcam_x/$webcam_y) I:($img_width/$img_height)";

            // resize output window based on image size
            if($img_width > 0 && $img_height > 0) {
                if($img_width > $webcam_x) {
                    if($img_height > $webcam_y) {
                        $diff_x = $img_width - $webcam_x;
                        $diff_y = $img_height - $webcam_y;

                        if ($diff_x > $diff_y) {
                            $wc_height = intval($webcam_x * $img_height / $img_width);
                         // print "1.1-($wc_width/$wc_height)";
                        } else {
                            $wc_width = intval($webcam_y * $img_width / $img_height);
                         // print "1.2-($wc_width/$wc_height)";
                        }
                    } else {
                        $wc_height = intval($webcam_x * $img_height / $img_width);
                     // print "1.6-($wc_width/$wc_height)";
                    }
                } elseif ($img_width < $webcam_x) {
                    if($img_height > $webcam_y) {
                        $wc_width = intval($webcam_y * $img_width / $img_height);
                     // print "2.1-($wc_width/$wc_height)";
                    } else {
                        $diff_x = $webcam_x - $img_width;
                        $diff_y = $webcam_y - $img_height;

                        if ($diff_x > $diff_y) {
                            $wc_width = intval($webcam_y * $img_width / $img_height);
                         // print "2.2-($wc_width/$wc_height)";
                        } else {
                            $wc_width  = $img_width;
                            $wc_height = $img_height;
                         // print "2.3-($wc_width/$wc_height)";
                        }
                    }
                }
            }
         // print "<br>";

            $title = "$camera_name $cam";
            echo "<Th>&nbsp;$title<a href=\"javascript:openwindow('$webcam', '$title', $wc_width + 20, $wc_height + 20, $cam);\">&nbsp;&nbsp;<img src=icon_video.gif border=0 alt=\"$see_camera\" title=\"$see_camera\"></a>&nbsp;</Th>";
        }
        echo "</tr>\n";

        $image = '';
        $timestamp = 0;
        $hour = -1;
        $camera_index = 0;
        $temp_td = '';
        $hour_event_count = 0;
        
        //
        // The $result recordset is expected with two record for each event
        // the first with the jpeg image (image_type = 1) and
        // the second with the avi file (image_type = 8), both with the same
        // event timestamp.
        //
        for($i = 0; $i < $numofrows; $i++) {
            $row = mysql_fetch_array($result); //get a row from our result set
            $ev_ts = $row['time_stamp'];

            //
            // file_type:  1 - image
            //             2 - image snapshot
            //             4 - image motion
            //             8 - mpeg
            //            16 - mpeg motion
            //            32 - mpeg timelaps
            //
            switch ($row['file_type']) {
                case 1: // jpeg file
                    // if is another image from the same event, ignore it
                    if ($ev_ts == $timestamp) continue 2;

                    $timestamp = $ev_ts;
                    $image = $row['filename'];
                    $file_type='jpg';
                    $file_type_desc="$file_type_picture_desc";
    
                    // jump to next loop to get correspondent movie file
                    continue 2;

                case 8: // movie file
                    // if isn't the same event, next row
                    if ($ev_ts != $timestamp) continue 2;
                    $file_type='avi';
                    $file_type_desc="$file_type_movie_desc";
                    break;

                case 32: // timelaps file
                    $image = create_movie_thumb($row['filename']);
                    $file_type='mpg';
                    $file_type_desc="$file_type_timelapse_desc";
                    break;

                default:
                    // if other type, ignore and jump to next row
                    $image = getcwd() . '/error.jpg';
                    continue 2;
            }

            // get hour and camera for this event
            $hourev = $row['hourfield'];
            $cameraev = $row['camera'];
//echo "HE:$hourev CE:$cameraev FT:$file_type IM:$image<br>\n";
        
            // has the hour changed?
            if ($hour != $hourev) {
                // if not first row (hour)
                if ($hour != -1) {
                    // if $temp_td not empty, flush it
                    if ($temp_td != '') {
                        echo '<td valign=top>'.$temp_td.'</td>';
                        $temp_td = '';
                        $camera_index++;
                    }

                    // while not the last column of this row ...
                    while ($camera_index < count($cameras)) {
                        echo "<td>&nbsp;</td>";
                        $camera_index++;
                    }

                    // end this row
                    echo "</tr>\n";
                    echo "<script language=JavaScript>\n<!--\ndocument.getElementById('countevents".$hour."').innerHTML = '".$hour_event_count."';\n//-->\n</script>\n";
                    $hour_event_count = 0;
                }

                // start a new row
                echo '<tr><td valign=top class=timeline-hour>'.substr($hourev+100,1).$hours.'</td>';
                echo "<td colspan=".$num_cameras." class=timeline-row-header>";
                echo "&nbsp;<a href=\"javascript:ToggleRowVisibility(".$row_count.");\">";
                echo '<img src=sign_plus.gif border=0 alt="' . $list_expand . '" title="' . $list_expand . '" onclick="plusclick(this);">';
                echo "</a>&nbsp;&nbsp;";
                echo "<span id=countevents".$hourev."></span> $events";
                echo "</td></tr>";
                echo '<tr><td class=timeline-hour>&nbsp;</td>';

                $row_count += 2;

                $camera_index = 0;
                $hour = $hourev;
            }

            // has camera changed?
            if ($cameraev != $cameras[$camera_index]) {
                // if $temp_td not empty, flush it
                if ($temp_td != '') {
                    echo '<td valign=top>'.$temp_td.'</td>';
                    $temp_td = '';
                    $camera_index++;
                }

                // go to the correct camera column
                while ($camera_index < count($cameras) AND $cameraev != $cameras[$camera_index]) {
                    echo '<td>&nbsp;</td>';
                    $camera_index++;
                }
            }

            // new event
            $event_count++;

            // if not the first event on this camera and hour, put a separation
            if ($temp_td) $temp_td .= "<hr size=1 width=95% color=gray>";

            // format file size
            empty($row['file_size']) ? $temp_fsize = read_filesize($row['filename'])/1024 : $temp_fsize = $row['file_size']/1024;

            if ($temp_fsize > 1024)
                // mega-byte
                $temp_fsize = number_format($temp_fsize/1024, 2, ',', '.') . $megabytes;
            else
                // kilo-byte
                $temp_fsize = number_format($temp_fsize, 2, ',', '.') . $kilobytes;

            // add to the $temp_td the html for this event
            $temp_td .= 
                "<a href=\"download.php?file=".$row['filename']."\">".
                "<img src=\"thumbnail.php?image=$image&width=$thumb_width&height=$thumb_height\" border=0>".
                "</a><br>".
                "<input type=checkbox name=img$event_count value=$ev_ts>".
                '<img src="sign_' . $file_type . '.gif" alt="' . $file_type_desc . '" title="' . $file_type_desc . '">&nbsp;&nbsp;'.
                $row['timefield'] . " (" . $temp_fsize . ")<br>";

            $hour_event_count++;

            // reset timestamp value because this event is complete
            $timestamp = 0;

        }

        // if $temp_td not empty, flush it
        if ($temp_td != '') {
            echo '<td valign=top>'.$temp_td.'</td>';
            $temp_td = '';
            $camera_index++;
        }

        // while not the last column of this row ...
        while ($camera_index < count($cameras)) {
            echo "<td>&nbsp;</td>";
            $camera_index++;
        }

        // end this row
        echo "</tr>\n";
        echo "<script language=JavaScript>\n<!--\ndocument.getElementById('countevents".$hour."').innerHTML = '".$hour_event_count."';\n//-->\n</script>\n";

        // now let's close the table and be done with it
        echo "</TABLE>\n";
    }
    else echo '<p><br>'.$no_events.'</p>';
    
    // close the main table
    echo '</td></tr></table>';

    // free $result variable    
    mysql_free_result($result);
    
    // set the number of event on this page and close the form
    echo "<input type=hidden name=event_count value=".$event_count.">\n";
    echo "</form>\n";

    // show disc quota
    if (isset($data_dir)) {
        $ratio= 1 - (disk_free_space($data_dir)/disk_total_space($data_dir) ) ;
        echo "<div class=\"quota\">\n";
        echo $vol1_quota . $data_dir . $vol2_quota . number_format($ratio*100, 2, ",", " ") . " %\n";
        echo "<img src=\"quota.php?ratio=" . $ratio . "\">\n";
        echo "</div>\n";
    }
?>

<script language="JavaScript">
<!--

// collapse the timeline table
for (i = 2; i < <?php echo $row_count; ?>; i += 2) ToggleRowVisibility(i);

<?
if ($ratio > .9) echo 'alert("' . $space1 . $data_dir . $low_space . ' ")';
?>
//-->
</script>

</body>
</html>
