<?php
/* ---------------------------------------------------------------------
    surveillance.php - MotionBrowser - User interface for the result of
                       Motion application. Developed by Carlos Ladeira
                       (caladeira@gmail.com)

    Creation:     2011-10-24 jed
    Last Update:  $Id: surveillance.php 29095 2011-11-08 19:00:20Z jed $

    For more details, please visit:
    http://www.lavrsen.dk/twiki/bin/view/Motion/WebHome

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
   -------------------------------------------------------------------- */

include("config.inc");
setlocale(LC_ALL, $locales);
include("calendar.inc");
include("lang_".$lang);

function parse_query($val) {
    // Use this function to parse out the query array element from
    // the output of parse_url()

    $var  = html_entity_decode($val);
    $var  = explode('&', $var);
    $arr  = array();

    foreach($var as $val) {
        $x  = explode('=', $val);
        $arr[$x[0]] = $x[1];
    }
    unset($val, $x, $var);

    return $arr; 
}

?>

<html>
<head>
<link rel="stylesheet" href="motionbrowser.css" type="text/css" media="all">
<script type="text/javascript">
<!--
    // returns the width/height of the body
    var body_x = window.innerWidth;
    var body_y = window.innerHeight;

    // set default values
    if (body_x <= 100) {
        body_x = 100;
    }

    if (body_y <= 100) {
        body_y = 100;
    }

    // read current url
    var url = window.location.href;

    var update=0;
    if (url.indexOf('&body_x=') <= 0) {
        // append parameter
        var url = url + '&body_x=' +  body_x;
        update=1;
    }

    if (url.indexOf('&body_y=') <= 0) {
        // append parameter
        var url = url + '&body_y=' +  body_y;
        update=1;
    }

    if(update == 1) {
        // update url
        window.location.href = url;
    }

//-->
</script>
<?php
    // read url string, e.g. 'http://server/motionbrowser/surveillance.php?title=Titel&nbr_x=3&nbr_y=1'
    $page_url = parse_url($_SERVER['REQUEST_URI']);

    // extract query part, e.g. 'title=Titel&nbr_x=3&nbr_y=1'
    $page_query = parse_query($page_url['query']);

    // extract values
    $win_width  = $page_query['body_x'];
    $win_height = $page_query['body_y'];
    $tile_nbr_x = $page_query['nbr_x'];
    $tile_nbr_y = $page_query['nbr_y'];

    print '<title>'.$surveillance_title.'</title>';
?>
</head>
<body>
<?php
    // read url string, e.g. 'http://server/motionbrowser/surveillance.php?title=Titel&nbr_x=3&nbr_y=1'
//  $page_url = parse_url($_SERVER['REQUEST_URI']);

    // extract query part, e.g. 'title=Titel&nbr_x=3&nbr_y=1'
//  $page_query = parse_query($page_url['query']);

    // extract values
//  $win_title = $page_query['title'];

//  $win_width  = $page_query['body_x'];
//  $win_height = $page_query['body_y'];
//  $tile_nbr_x = $page_query['nbr_x']; 
//  $tile_nbr_y = $page_query['nbr_y']; 

    $tile_width  = intval($win_width/$tile_nbr_x-15);
    $tile_height = intval($win_height/$tile_nbr_y-40);

    for ($row = 1; $row <= $tile_nbr_y; $row++) {
        for ($col = 1; $col <= $tile_nbr_x; $col++) {
            // show live streams in a combined surveillance view
            $tile_url = "http://$server_name:".$webcam_port[($col-1)]."/";
            print '<iframe src="'.$tile_url.'" name="'.$camera_name.'-'.($col-1).'" width="'.$tile_width.'" height="'.$tile_height.'">';
            print '</iframe>';
        }
    }
?>
</body>
</html>
