#!/bin/sh
#----------------------------------------------------------------------------------------
# /[data/packages|var]/motion/motion_change_owner.sh - change file and directory ownership
#
# Copyright (c) 2011 The Eisfair Team, team(at)eisfair(dot)org
#
# Creation:     2011-10-17  jed
# Last Update:  $Id: motion_change_owner.sh 29043 2011-10-27 18:50:48Z jed $
#
# Usage:        motion_change_owner.sh filename|%f
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#----------------------------------------------------------------------------------------

# read eislib etc.
. /var/install/include/check-eisfair-version
. /var/install/include/jedlib

#exec 2>/tmp/motion-change-owner-$$.log
#set -x

testroot=/tmp/jedmotion
apache2file=${testroot}/etc/config.d/apache2

# set platform specific parameters
case ${EISFAIR_SYSTEM} in
    eisfair-1)
        # eisfair-1
	def_doc_root=/var/www/htdocs
        motion_apache_user="wwwrun"
        motion_apache_group="nogroup"
        ;;
    *)
        # default eisfair-2
        def_doc_root=/data/www/htdocs
        motion_apache_user="www-data"
        motion_apache_group="www-data"
        ;;
esac

### load apache2 configuration ###
if [ -f ${apache2file} ]
then
    webtmp=/tmp/motionroot.$$

    grep "^APACHE2_DOCUMENT_ROOT" ${apache2file} > ${webtmp}
    . ${webtmp}
    rm -f ${webtmp}
else
    APACHE2_DOCUMENT_ROOT=${def_doc_root}
fi

if [ "$1" != "" ]
then
    fpname="$1"

    exitflag=1
    while [ ${exitflag} -eq 1 ]
    do
	if [ -f ${fpname} -o -d ${fpname} ]
        then
            chown ${motion_apache_user}  ${fpname}
            chgrp ${motion_apache_group} ${fpname}
        fi

        # shorten path
        fpname="`echo "${fpname}" | sed 's#/[-0-9a-zA-Z_.]*$##'`"

        if [ "${fpname}" = "${APACHE2_DOCUMENT_ROOT}/motion" -o "${fpname}" = "" ]
        then
            exitflag=0
        fi
    done
fi
