#!/bin/sh
#----------------------------------------------------------------------------------------
# /[data/packages|var]/motion/motion_collect_jpg.sh - collect pictures in special folder
#
# Copyright (c) 2008-2011 The Eisfair Team, team(at)eisfair(dot)org
#
# Creation:     2004-09-05  jed
# Last Update:  $Id: motion_collect_jpg.sh 29043 2011-10-27 18:50:48Z jed $
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#----------------------------------------------------------------------------------------

. /var/install/include/jedlib

# collect pictures into special folder
if [ $# -eq 3 ]
then
    # valid number of parameter
    m_picture_name=$1
    m_collect_path=$2
    m_collect_count=$3

    if [ -f ${m_picture_name} ]
    then
        # source file
        if [ -d ${m_collect_path} ]
        then
            # destination directory exists
            if is_numeric ${m_collect_count}
            then
                # numeric value, copy picture
                cp ${m_picture_name} ${m_collect_path}/`date +%d%m%y-%k%M%S`.jpg
      
                # handle the counter
                num_files=`find ${m_collect_path}/*.jpg | wc -l`

                while [ ${num_files} -gt ${m_collect_count} ]
                do
                    oldest=`ls -1t ${m_collect_path} | tail -n 1`
                    rm -f ${m_collect_path}/${oldest}
                    num_files=`find ${m_collect_path}/*.jpg | wc -l`
	            done
            else
                # value not numeric
                echo "Error: value '${m_collect_count}' not numeric!"
            fi
        else
            # path doesn't exist
            echo "Error: destination path '${m_collect_path}' doesn't exist!"
        fi
    else
        echo "Error: source file '${m_picture_name}' doesn't exist!"
    fi
else
    # insufficient parameters
    echo "Error: unsufficient number of parameters!"
    echo
    echo "Usage $0 source-file destination-directory max-files"
fi
