#!/bin/sh
#----------------------------------------------------------------------------------------
# /[data/packages|var]/motion/motion_update_db_fields.sh - update fields in database
#
# Copyright (c) 2011 The Eisfair Team, team(at)eisfair(dot)org
#
# Creation:     2011-12-05  jed
# Last Update:  $Id: motion_update_db_fields.sh 29430 2012-01-01 13:39:35Z jed $
#
# Usage:        motion_update_filesize.sh filename|%f
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#----------------------------------------------------------------------------------------

# read eislib etc.
. /var/install/include/check-eisfair-version
. /var/install/include/jedlib

#exec 2>/tmp/motion_update_db_fields-$$.log
#set -x

testroot=/tmp/jedmotion

motionfile=/etc/config.d/motion

MOTION_SQL_HOST='localhost'
MOTION_SQL_DATABASE='motiondb'
MOTION_SQL_TABLE='security'

if [ "$1" != "" ]
then
    fname="$1"

    ### load motion configuration ###
    if [ -f ${motionfile} ]
    then
        # load configuration
        . ${motionfile}

        if [ -f ${fname} ]
        then
            # get file size
            fsize="`stat -c '%s' ${fname}`"

            # update file size in sql database
            basename ${fname} | grep -q "timelapse"

            if [ $? -eq 0 ]
            then
                # get day number
                day="`basename ${fname} | cut -d- -f1`"

                # timelaps video, update fields 'file_size', 'event_time_stamp', 'time_stamp'
                /usr/local/mysql/bin/mysql -h${MOTION_SQL_HOST} -u${MOTION_SQL_USER} -p${MOTION_SQL_PASS} -D${MOTION_SQL_DATABASE} -e"UPDATE security SET file_size='${fsize}', event_time_stamp=IF(event_time_stamp='0000-00-00 00:00:00', DATE_ADD(DATE_FORMAT(time_stamp, '%Y-%m-${day}'), INTERVAL '23:59:59' HOUR_SECOND), event_time_stamp), time_stamp=time_stamp WHERE filename='${fname}'"
            else
                # all other files, update only field 'file_size'
                /usr/local/mysql/bin/mysql -h${MOTION_SQL_HOST} -u${MOTION_SQL_USER} -p${MOTION_SQL_PASS} -D${MOTION_SQL_DATABASE} -e"UPDATE security SET file_size='${fsize}' WHERE filename='${fname}'"
            fi
        fi
    fi
fi
